package eu.etaxonomy.taxeditor.prototype2.model;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

import eu.etaxonomy.cdm.model.taxon.Taxon;

/**
 * @author p.ciardelli
 *
 */
public class NameEditorInput implements IEditorInput {

	private Taxon taxon;
	
	public NameEditorInput (Taxon taxon) {
		this.taxon = taxon;
	}
	
	public boolean exists() {
		// TODO Auto-generated method stub
		return false;
	}

	public ImageDescriptor getImageDescriptor() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getName() {
		if (taxon.getName().getNameCache() == null)
			return "New taxon";
		else
			return taxon.getName().getNameCache();
	}

	public IPersistableElement getPersistable() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getToolTipText() {
		return getName();
	}

	public Object getAdapter(Class adapter) {

		if (adapter == Taxon.class) {
			return this.taxon;
		}
		
		return null;
	}

    /**
     * Overrides equals to ensure that a taxon can only be edited by
     *  one editor at a time.
     * 
     * @return boolean
     */
	public boolean equals(Object obj) {		
		if (this.taxon.equals(((NameEditorInput) obj).taxon))
			return true;
		return false;
	}
}
