package eu.etaxonomy.taxeditor;

import org.eclipse.ui.application.IWorkbenchConfigurer;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchAdvisor;
import org.eclipse.ui.application.WorkbenchWindowAdvisor;

public class ApplicationWorkbenchAdvisor extends WorkbenchAdvisor {

	private static final String PERSPECTIVE_ID = "eu.etaxonomy.taxeditor.perspective.freetextproperties";

	public WorkbenchWindowAdvisor createWorkbenchWindowAdvisor(
			IWorkbenchWindowConfigurer configurer) {
		return new ApplicationWorkbenchWindowAdvisor(configurer);
	}

	public String getInitialWindowPerspectiveId() {
		return PERSPECTIVE_ID;
	}
	
	public void initialize(IWorkbenchConfigurer configurer) {
		super.initialize(configurer);
				
		// Remembers the user's view layout, window size, window location etc.
		//  for the next time application is started
		
		// IMPORTANT as we don not have a mechanism to open views via a menu
		// at the moment this has to be set to false everytime a new view is added,
		// otherwise the view will not show because it is not stored in the memento
		configurer.setSaveAndRestore(false);		
	}
}
