/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor;

import org.apache.log4j.Logger;
import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

import eu.etaxonomy.taxeditor.navigation.RecentNamesView;
import eu.etaxonomy.taxeditor.navigation.SearchView;
import eu.etaxonomy.taxeditor.navigation.TaxonomicTreeView;

/**
 * @author p.ciardelli
 * @created 15.05.2008
 * @version 1.0
 */
public class FreetextPropertiesPerspective implements IPerspectiveFactory {
	private static final Logger logger = Logger.getLogger(FreetextPropertiesPerspective.class);
	/*
	 * To remember the user's layout and window sizes for the next time they 
	 *  start your application, add configurer.setSaveAndRestore(true); to the 
	 *  initialize() method of WorkbenchAdvisor.
	 *  
	 *  IMPORTANT:
	 *  If you set configurer.setSaveAndRestore(true) and you are adding a new view 
	 *  to the perspective make sure you set it to false for at least one start. 
	 *  Otherwise the new view will not show.
	 *  
	 */
	
	public static final String ID = "eu.etaxonomy.taxeditor.perspective.freetextproperties";
	
	public void createInitialLayout(IPageLayout layout) {
		String editorArea = layout.getEditorArea();
		
		// Note: plug-in org.eclipse.ui.ide necessary for 
		//  IPageLayout.ID_PROBLEM_VIEW ("org.eclipse.ui.views.ProblemView") to run
//		layout.addView(IPageLayout.ID_PROBLEM_VIEW, IPageLayout.BOTTOM, 0.8f, editorArea);		
		
		IFolderLayout folderLayoutLeft = layout.createFolder("leftfolder", IPageLayout.LEFT, 0.3f, editorArea);
		
		folderLayoutLeft.addView(TaxonomicTreeView.ID);
		folderLayoutLeft.addView(SearchView.ID);
		
		IFolderLayout folderLayoutBottomLeft = layout.createFolder("bottomleftfolder", IPageLayout.BOTTOM, 0.75f, "leftfolder");
		folderLayoutBottomLeft.addView(RecentNamesView.ID);
//		folderLayoutBottomLeft.addView(FavoritesView.ID);
		
		IFolderLayout folderLayoutRight = layout.createFolder("rightfolder", IPageLayout.RIGHT, 0.5f, editorArea);		
		folderLayoutRight.addView(IPageLayout.ID_PROP_SHEET);
////		folderLayoutRight.addView(IPageLayout.ID_PROBLEM_VIEW);
		
		layout.getViewLayout(IPageLayout.ID_PROP_SHEET).setCloseable(false);
		layout.getViewLayout(IPageLayout.ID_PROP_SHEET);
		layout.getViewLayout(TaxonomicTreeView.ID).setCloseable(false);		
		
		layout.setFixed(false);
		
//		layout.createPlaceholderFolder(folderId, relationship, ratio, refId);
	}
}
