/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.controller;

import org.apache.log4j.Logger;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;

import eu.etaxonomy.taxeditor.navigation.SearchResult;
import eu.etaxonomy.taxeditor.navigation.SearchResultView;

/**
 * @author n.hoffmann
 * @created 20.01.2009
 * @version 1.0
 */
public class SearchController {
	private static final Logger logger = Logger
			.getLogger(SearchController.class);
	private static String srv = "";

	public static void openSearchResultsView(SearchResult searchResult) {
		srv += "1";
		logger.info("Opening search results window " + srv);
		try {
			IViewPart resultsView = GlobalController.getActivePage().showView(SearchResultView.ID, 
					srv, IWorkbenchPage.VIEW_VISIBLE);
			((SearchResultView) resultsView).setResult(searchResult);
		} catch (PartInitException e) {
			logger.error("Error opening search result.", e);
		}
	}
}
