
package eu.etaxonomy.taxeditor.propertysheet;

import java.util.Collection;

import org.apache.log4j.Logger;

import eu.etaxonomy.cdm.model.common.Marker;
import eu.etaxonomy.cdm.model.common.MarkerType;

public class MarkersPropertySource extends CollectionPropertySource {
	private static final Logger logger = Logger
			.getLogger(MarkersPropertySource.class);


	public MarkersPropertySource(Collection collection) {
		super(collection);
//		logger.warn("Markers collection contains " + collection.size() + " elements.");
	}

	protected void addDescriptor(Object item) {
		String itemDisplayName = getItemDisplayName(item);
		descriptors.addElement(
				new CheckboxPropertyDescriptor(item, itemDisplayName));
	}
	
	@Override
	protected String getItemDisplayName(Object item) {
		String itemDisplayName = "";
		if (item instanceof Marker) {
			Marker marker = (Marker) item;
			MarkerType markerType = marker.getMarkerType();
			if (markerType != null) {
				return markerType.getLabel();
			}
		}
		return itemDisplayName;
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id instanceof Marker) {
			Marker marker = (Marker) id;
			if (marker.getFlag()) {
				return Boolean.TRUE;
			} else {
				return Boolean.FALSE;
			}
		}
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		if (id instanceof Marker && value instanceof Boolean) {
			logger.warn("Updating marker values");
			Marker marker = (Marker) id;
			marker.setFlag((Boolean) value);
		} else {
			logger.warn("Marker update failed type checks");			
		}
	}

	@Override
	public String toString() {
		// "Markers" header has no value
		return "";
	}
}