package eu.etaxonomy.taxeditor;

import org.eclipse.ui.application.IWorkbenchConfigurer;
import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
import org.eclipse.ui.application.WorkbenchAdvisor;
import org.eclipse.ui.application.WorkbenchWindowAdvisor;

public class ApplicationWorkbenchAdvisor extends WorkbenchAdvisor {

	private static final String PERSPECTIVE_ID = Perspective.ID;

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.application.WorkbenchAdvisor#createWorkbenchWindowAdvisor(org.eclipse.ui.application.IWorkbenchWindowConfigurer)
	 */
	public WorkbenchWindowAdvisor createWorkbenchWindowAdvisor(
			IWorkbenchWindowConfigurer configurer) {
		return new ApplicationWorkbenchWindowAdvisor(configurer);
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.application.WorkbenchAdvisor#getInitialWindowPerspectiveId()
	 */
	public String getInitialWindowPerspectiveId() {
		return PERSPECTIVE_ID;
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.application.WorkbenchAdvisor#initialize(org.eclipse.ui.application.IWorkbenchConfigurer)
	 */
	public void initialize(IWorkbenchConfigurer configurer) {
		super.initialize(configurer);
				
		// Remembers the user's view layout, window size, window location etc.
		//  for the next time application is started
		configurer.setSaveAndRestore(true);		
	}	
	

//	public void initialize(IWorkbenchConfigurer configurer) {
//
//		WorkbenchAdapterBuilder.registerAdapters();
//
//		final String ICONS_PATH = "icons/full/";
//		final String PATH_OBJECT = ICONS_PATH + "obj16/";
//		Bundle ideBundle = Platform.getBundle(IDEWorkbenchPlugin.IDE_WORKBENCH);
//		declareWorkbenchImage(configurer, ideBundle,
//				IDE.SharedImages.IMG_OBJ_PROJECT, PATH_OBJECT + "prj_obj.gif",
//				true);
//		declareWorkbenchImage(configurer, ideBundle,
//				IDE.SharedImages.IMG_OBJ_PROJECT_CLOSED, PATH_OBJECT
//						+ "cprj_obj.gif", true);
//
//	}
//
//	private void declareWorkbenchImage(IWorkbenchConfigurer configurer_p,
//			Bundle ideBundle, String symbolicName, String path, boolean shared) {
//		URL url = ideBundle.getEntry(path);
//		ImageDescriptor desc = ImageDescriptor.createFromURL(url);
//		configurer_p.declareImage(symbolicName, desc, shared);
//	}
//
//	public IAdaptable getDefaultPageInput() {
//		IWorkspace workspace = ResourcesPlugin.getWorkspace();
//		return workspace.getRoot();
//	}

}
