// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.IStatusLineManager;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IEditorPart;

import eu.etaxonomy.cdm.model.reference.ReferenceBase;
import eu.etaxonomy.taxeditor.propertysheet.reference.ReferencePropertySource;

/**
 * @author p.ciardelli
 * @created 07.07.2009
 * @version 1.0
 */
public class BulkEditorLineDisplay implements ILineDisplayStrategy {
	private static final Logger logger = Logger
			.getLogger(BulkEditorLineDisplay.class);
	
	private IEditorPart editor;

	/**
	 * @param bulkEditor
	 */
	public BulkEditorLineDisplay(IEditorPart editor) {
		this.editor = editor;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.ILineDisplayStrategy#getIcon(java.lang.Object)
	 */
	public Image getIcon(Object entity) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.ILineDisplayStrategy#getIndent(java.lang.Object)
	 */
	public int getIndent(Object entity) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.ILineDisplayStrategy#getPropertySource(java.lang.Object)
	 */
	public Object getPropertySource(Object entity) {
		if (entity instanceof ReferenceBase) {
			return new ReferencePropertySource((ReferenceBase) entity);			
		}
		return null;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.ILineDisplayStrategy#getText(java.lang.Object)
	 */
	public String getText(Object entity) {		
		if (entity instanceof ReferenceBase) {
			return ((ReferenceBase) entity).getTitleCache();
		}
		return null;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.ILineDisplayStrategy#setText(java.lang.String, java.lang.Object)
	 */
	public void setText(String text, Object entity) {
		if (entity instanceof ReferenceBase) {
			((ReferenceBase) entity).setTitleCache(text);			
		}
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.ILineDisplayStrategy#getHoverText(java.lang.Object)
	 */
	public String getHoverText(Object entity) {
		return null;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.ILineDisplayStrategy#setStatusMessage(java.lang.String, java.lang.Object)
	 */
	public void setStatusMessage(final String text, Object entity) {
		
		// Calling from the synchronized method ListEditorReconcilingStrategy#doReconcile
		// without its own thread causes an invalid thread access exception
		// see http://wiki.eclipse.org/FAQ_Why_do_I_get_an_invalid_thread_access_exception%3F
		new Thread(new Runnable() {
			public void run() {
				Display.getDefault().asyncExec(new Runnable() {
					public void run() {
						IStatusLineManager statusLineManager = editor.getEditorSite().getActionBars().getStatusLineManager();
						statusLineManager.setMessage(text);
					}
				});
			}
		}).start();
	}
}
