// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author p.ciardelli
 * @created 07.07.2009
 * @version 1.0
 */
public class BulkEditorPersistenceService implements IEntityPersistenceService {
	private static final Logger logger = Logger
			.getLogger(BulkEditorPersistenceService.class);
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IEntityPersistenceService#getEntityList(java.lang.Object)
	 */
	public List<?> getEntityList(Object element) {
//		List entityList = new ArrayList();
//		
//		ReferenceCreator creator = new ReferenceCreator();
//		
//		entityList.add(creator.createEntity("Acta universitatis carolinae. Biologica Prague"));
//		entityList.add(creator.createEntity("Acta universitatis asiae mediae. Botanica"));
//		entityList.add(creator.createEntity("Acta phytogeographica suecica Uppsala"));
//		entityList.add(creator.createEntity("Acta botanica neerlandica Amsterdam"));
//		entityList.add(creator.createEntity("Acta geobotanica hungarica Debrecen, Hungary"));
//		return entityList;
		
		return CdmStore.getReferencesByTitle("S*");
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IEntityPersistenceService#create(java.lang.Object, java.lang.Object)
	 */
	public boolean create(Object entity, Object element) {
		logger.info("Create "  + entity);
		return true;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IEntityPersistenceService#delete(java.lang.Object, java.lang.Object)
	 */
	public boolean delete(Object entity, Object element) {
		logger.info("Delete "  + entity);
		return true;
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IEntityPersistenceService#merge(java.lang.Object, java.lang.Object, java.lang.Object)
	 */
	public boolean merge(Object entity, Object mergeTarget, Object element) {
		logger.info("Merge "  + entity + " into " + mergeTarget);
		return true;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.IEntityPersistenceService#save(java.lang.Object, java.lang.Object)
	 */
	public boolean save(Object entity, Object element) {
		logger.info("Save "  + entity);
		return true;
	}
}
