// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor.referencingobjects;

import java.util.Set;

import eu.etaxonomy.cdm.model.common.CdmBase;


/**
 * Provides access to the domain layer to translate a workbench selection into 
 * an object and the objects that reference it.  
 * 
 * @author p.ciardelli
 * @created 09.07.2009
 * @version 1.0
 */
public interface IReferencingObjectsService {

	/**
	 * @param entity
	 * @return
	 */
	CdmBase getReferencedObject(Object entity);
	
	/**
	 * @param entity
	 * @return
	 */
	Set<CdmBase> getReferencingObjects(Object entity);

	/**
	 * @param element
	 * @return
	 */
	String getObjectClass(Object element);

	/**
	 * @param element
	 * @return
	 */
	String getObjectDescription(Object element);
	
}
