// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.description;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.views.properties.IPropertySource;

import eu.etaxonomy.cdm.model.description.Distribution;
import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
import eu.etaxonomy.cdm.model.location.NamedArea;
import eu.etaxonomy.taxeditor.propertysheet.description.DistributionPropertySource;

/**
 * @author p.ciardelli
 * @created 02.04.2009
 * @version 1.0
 */
public class DistributionComposite extends DescriptionElementComposite {
	
	/**
	 * @param groupComposite
	 * @param groupComposite
	 * @param element
	 */
	public DistributionComposite(TaxonDescriptionEditor editor, Composite groupComposite,
			 Distribution element) {
		super(editor, groupComposite, element);
	}
	
	

	public IPropertySource getPropertySource() {
		return new DistributionPropertySource((Distribution) getElement());
	}



	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.description.DescriptionElementComposite#initTextViewer()
	 */
	@Override
	protected void initTextViewer() {
		
		Distribution distribution = (Distribution) getElement();
		
		NamedArea area = distribution.getArea();
		PresenceAbsenceTermBase<?> status = distribution.getStatus();
		
		if (status != null) {
			String text = area.getLabel() + ", " + status.getLabel();
			textViewer.getTextWidget().setText(text);
		}
		
		
		textViewer.getTextWidget().setEditable(false);
	}
}