// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.description;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
import eu.etaxonomy.cdm.model.description.Distribution;
import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.cdm.model.description.TaxonDescription;

/**
 * @author n.hoffmann
 * @created 26.05.2009
 * @version 1.0
 */
public class DistributionFeatureGroupComposite extends DescriptionFeatureGroupComposite implements MouseListener{
	
	private Set<Distribution> distributions;

	private Button showMapButton;
	
	public DistributionFeatureGroupComposite(TaxonDescriptionEditor editor, Composite parent, 
			TaxonDescription description, Feature feature) {
		super(editor, parent, description, feature);
		
		distributions = new HashSet<Distribution>();
		
		for(DescriptionElementBase descriptionElement : description.getElements()){
			if(descriptionElement.getFeature().equals(Feature.DISTRIBUTION())){
				distributions.add((Distribution) descriptionElement);
			}
		}
		
		showMapButton = new Button(parent, SWT.PUSH);
		showMapButton.setText("Show Map");
		showMapButton.addMouseListener(this);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.widgets.Listener#handleEvent(org.eclipse.swt.widgets.Event)
	 */
	public void mouseUp(MouseEvent event) {
		if(event.widget == showMapButton){
		
			DistributionMapDialog dialog = new DistributionMapDialog(editor, this.getShell());
			
			dialog.open();
		}
	}

	public void mouseDoubleClick(MouseEvent e) {}

	public void mouseDown(MouseEvent e) {}
}
