/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.labels;

import java.util.SortedSet;

import org.eclipse.swt.graphics.Image;

import eu.etaxonomy.cdm.model.name.NameRelationship;
import eu.etaxonomy.cdm.model.name.NameRelationshipType;
import eu.etaxonomy.taxeditor.model.ImageResources;
import eu.etaxonomy.taxeditor.store.VocabularyStore;

/**
 * @author p.ciardelli
 *
 */
public class DefaultLabelStrategy implements ILabelImageStrategy {

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.labels.IEditorLabelStrategy#getNameRelationTypeLabel(eu.etaxonomy.cdm.model.name.NameRelationshipType)
	 */
	public String getNameRelationTypeLabel(NameRelationshipType type) {
		SortedSet<NameRelationshipType> vocab = 
			VocabularyStore.getNameRelationshipTypes();
	
		for (NameRelationshipType type1 : vocab) {
			if (type1.equals(type)) {
				return type1.getLabel();
			}
		}
		return "";
	}
		
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.labels.IEditorLabelStrategy#getNameRelationInverseTypeLabel(eu.etaxonomy.cdm.model.name.NameRelationshipType)
	 */
	public String getNameRelationTypeInverseLabel(NameRelationshipType type) {
		
		SortedSet<NameRelationshipType> vocab = 
			VocabularyStore.getNameRelationshipTypes();

		for (NameRelationshipType type1 : vocab) {
			if (type1.equals(type)) {
				return type1.getInverseLabel();
			}
		}
		return "";
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.labels.ILabelImageStrategy#getNameRelationImage(eu.etaxonomy.cdm.model.name.NameRelationship)
	 */
	public Image getNameRelationImage(NameRelationship relation) {
		if (relation.getType().equals(NameRelationshipType.BASIONYM())) {
			return ImageResources.getImage(
					ImageResources.BASIONYM_ICON);
		}
		if (relation.getType().equals(
				NameRelationshipType.ORTHOGRAPHIC_VARIANT())) {
			return ImageResources.getImage(
					ImageResources.ORTHOGRAPHIC_VARIANT_ICON);
		}
		return null;
	}
}