/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.labels;

import org.apache.log4j.Logger;
import org.eclipse.core.expressions.PropertyTester;

import eu.etaxonomy.cdm.model.name.NomenclaturalCode;
import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.taxeditor.propertysheet.name.SynonymPropertySource;

public class LabelPropertyTester extends PropertyTester {
	private static final Logger logger = Logger.getLogger(LabelPropertyTester.class);
	
	private static final Object IS_ZOOLOGICAL = "isZoological";
	
	public boolean test(Object receiver, String property, Object[] args,
			Object expectedValue) {
		
		if (IS_ZOOLOGICAL.equals(property) && receiver instanceof SynonymPropertySource) {
			TaxonNameBase name = ((SynonymPropertySource) receiver).
									getTaxonBase().getName();
			return (name.getNomenclaturalCode().equals(NomenclaturalCode.ICZN));			
		}
		return false;
	}
}
