/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.labels;

import org.apache.log4j.Logger;
import org.eclipse.swt.graphics.Image;

import eu.etaxonomy.cdm.model.name.NameRelationship;
import eu.etaxonomy.cdm.model.name.NameRelationshipType;

/**
 * @author p.ciardelli
 *
 */
public class ZoologicalNameLabelStrategy extends DefaultLabelStrategy {
	private static final Logger logger = Logger.getLogger(ZoologicalNameLabelStrategy.class);

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.labels.IEditorLabelStrategy#getNameRelationTypeLabel(eu.etaxonomy.cdm.model.name.NameRelationshipType)
	 */
	public String getNameRelationTypeLabel(NameRelationshipType type) {
		if (type.equals(NameRelationshipType.BASIONYM())) {
			return "original combination for";
		}
		return super.getNameRelationTypeLabel(type);
	}
	
	public Image getNameRelationImage(NameRelationship relation) {
		if (relation.getType().equals(NameRelationshipType.BASIONYM())) {
			return null;
		}
		return super.getNameRelationImage(relation);
	}
}
