/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.name.handler;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.Page;
import eu.etaxonomy.taxeditor.editor.name.TaxonNameEditor;
import eu.etaxonomy.taxeditor.propertysheet.name.TaxonBasePropertySource;

/**
 * @author p.ciardelli
 *
 */
public class ChangeAcceptedTaxonToSynonymHandler extends AbstractHandler
		implements IHandler {

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		
//		MessageDialog.openInformation(HandlerUtil.getActiveShell(event), 
//				"Not yet implemented", 
//				"'Change Accepted Taxon to Synonym' not yet implemented.");
		
		TaxonNameEditor editor = (TaxonNameEditor) EditorUtil.getActiveEditorPage(
				Page.NAME);
		ISelection menuSelection = HandlerUtil.getActiveMenuSelection(event);
		
		
		
		TaxonBasePropertySource taxonBasePropertySource = 
				(TaxonBasePropertySource) ((StructuredSelection) menuSelection).getFirstElement();
		Taxon taxon = (Taxon) taxonBasePropertySource.getTaxonBase();
		
		Taxon newAcceptedTaxon = FilteredTaxonSelectionDialog.getTaxon(HandlerUtil.getActiveShell(event), taxon);
//		TaxonNameBase newTaxonName = FilteredNameSelectionDialog.getName(HandlerUtil.getActiveShell(event), taxon.getName());
		
		
//		IEditorInput input = TaxonEditorInput.NewInstance(newAcceptedTaxon.getUuid()); 
		try {
			TaxonNode taxonNode = newAcceptedTaxon.getTaxonNodes().iterator().next();
			EditorUtil.open(taxonNode.getUuid());
		} catch (PartInitException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return null;
	}
}