/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.name.handler;

import java.util.List;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.dialogs.FilteredCdmResourceSelectionDialog;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author p.ciardelli
 *
 */
public class FilteredTaxonSelectionDialog extends FilteredCdmResourceSelectionDialog {
	private static final Logger logger = Logger
			.getLogger(FilteredTaxonSelectionDialog.class);

	/**
	 * @param taxon
	 * @return
	 */
	public static Taxon getTaxon(Shell shell, Taxon excludeTaxon) {
		FilteredTaxonSelectionDialog dialog = new FilteredTaxonSelectionDialog(shell, 
				"Choose a taxon");
		if (dialog.open() == Window.CANCEL) {
			return null;
		}
		return dialog.getTaxon();
	}

	private Taxon taxon;

	/**
	 * @param shell
	 * @param title
	 */
	public FilteredTaxonSelectionDialog(Shell shell, String title) {
		super(shell, title);
		setMessage("Choose your shit here, bro");
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.FilteredCdmResourceSelectionDialog#getSettings()
	 */
	@Override
	public String getSettings() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.dialogs.FilteredItemsSelectionDialog#fillContentProvider(org.eclipse.ui.dialogs.FilteredItemsSelectionDialog.AbstractContentProvider, org.eclipse.ui.dialogs.FilteredItemsSelectionDialog.ItemsFilter, org.eclipse.core.runtime.IProgressMonitor)
	 */
	@Override
	protected void fillContentProvider(AbstractContentProvider contentProvider,
			ItemsFilter itemsFilter, IProgressMonitor progressMonitor)
			throws CoreException {
		progressMonitor.beginTask("Looking for taxa", 1000);
		List allTaxonBases = CdmStore.searchTaxaByName("*"+itemsFilter.getPattern()+"*");
		for (Object obj : allTaxonBases){
			if (obj instanceof Taxon) {
				contentProvider.add((Taxon) obj, itemsFilter);
			}
			progressMonitor.worked(1);
		}
	}
		
	/**
	 * @return
	 */
	private Taxon getTaxon() {
		Object[] result = getResult();
		return result[0] == null ? null : (Taxon) result[0];
	}
}