/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.navigation.taxonomictree;

import java.util.List;

import org.eclipse.core.runtime.Assert;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import eu.etaxonomy.cdm.model.taxon.Taxon;

/**
 * TODO maybe we want to implement ILazyTreeContentProvider
 * 
 * @author p.ciardelli
 * @created 27.06.2008
 * @version 1.0
 * @author n.hoffmann
 */
@Deprecated public class TaxonomicTreeContentProvider implements ITreeContentProvider {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITreeContentProvider#getChildren(java.lang.Object)
	 */
	public Object[] getChildren(Object parentElement) {
		
		String errorMessage = "getChildren(parentElement) called with non-Taxon element.";
		
		// Make sure we are dealing with taxon objects
		Assert.isTrue(parentElement instanceof Taxon, errorMessage);
		
		if (parentElement instanceof Taxon) {
			return ((Taxon) parentElement).getTaxonomicChildren().toArray();
		}

		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITreeContentProvider#getParent(java.lang.Object)
	 */
	public Object getParent(Object element) {
		
		Assert.isTrue(element instanceof Taxon, 
				"getParent(element) called with non-Taxon element.");
		
		return ((Taxon) element).getTaxonomicParent();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITreeContentProvider#hasChildren(java.lang.Object)
	 */
	public boolean hasChildren(Object element) {
		Assert.isTrue(element instanceof Taxon, 
				"hasChildren(element) called with non-Taxon element.");
		
		return ((Taxon) element).getTaxonomicChildrenCount() > 0;
	}

	
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
	 */
	@SuppressWarnings("unchecked")
	public Object[] getElements(Object inputElement) {	
		List<Taxon> rootTaxa = (List<Taxon>) inputElement;
		return rootTaxa.toArray();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
	 */
	public void dispose() {}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer,
	 *      java.lang.Object, java.lang.Object)
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}
}