/**
 * 
 */
package eu.etaxonomy.taxeditor.navigation.taxonomictree;

import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.navigator.IDescriptionProvider;

import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.editor.name.IterableSynonymyList;
import eu.etaxonomy.taxeditor.model.NameHelper;

/**
 * 
 * @author n.hoffmann
 * @created 18.03.2009
 * @version 1.0
 */
@Deprecated public class TaxonomicTreeLabelProvider extends ColumnLabelProvider implements ILabelProvider, IDescriptionProvider  {

	public Image getImage(Object element) {
		// This code was to distinct a missaplied name from a accepted taxon name 
		// in the taxonomic tree. Unfortunately lazy loading slows this down, so that
		// the taxonomic tree will take 10 minutes to initialize.
		// I will leave this in here as a reminder.
//		if (element instanceof Taxon){
//			if(((Taxon) element).isMisappliedName()){
//				// return misapplication image
//				return PlatformUI.getWorkbench().getSharedImages().getImage(
//						ISharedImages.IMG_ELCL_SYNCED); 
//			}
//			// return standard taxon image
//			return PlatformUI.getWorkbench().getSharedImages().getImage(
//					ISharedImages.IMG_OBJS_INFO_TSK); 
//		}
		
		
		// No image for now
		return null;
	}

	public String getText(Object element) {
		if (element instanceof Taxon) {
			Taxon data = (Taxon) element;
			return data.getName().getTitleCache(); //$NON-NLS-1$
		}  
		return null;
	}

	public String getDescription(Object anElement) {
		if (anElement instanceof Taxon) {
			Taxon data = (Taxon) anElement;
			return "Taxon: " + data.getTitleCache(); //$NON-NLS-1$
		}
		return null;
	}

	public String getToolTipText(Object element) {
		if (element instanceof Taxon) {
			return getSynonymyListDisplay((Taxon) element);
		}
		return null;
	}
	
	/**
	 * @param taxon 
	 * @return
	 */
	private String getSynonymyListDisplay(Taxon taxon) {
		IterableSynonymyList synonymyList = new IterableSynonymyList(
				taxon);
		String synonymyListDisplay = NameHelper
				.getDisplayName(taxon);
		
		for (TaxonBase<?> synonymOrMisName : synonymyList) {
			TaxonNameBase<?, ?> name = synonymOrMisName.getName();
			if (name != null) {
				synonymyListDisplay += "\n      "
						+ NameHelper.getDisplayName(name);
			}
		}
		return synonymyListDisplay;
	}	
}
