// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.dialogs;

import java.util.List;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.cdm.model.reference.ReferenceBase;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created 04.06.2009
 * @version 1.0
 */
public class FilteredNameSelectionDialog extends FilteredCdmResourceSelectionDialog {
	/**
	 * @param shell
	 * @param title
	 */
	public FilteredNameSelectionDialog(Shell shell) {
		super(shell, "Select Name");
	}

	private static final Logger logger = Logger
			.getLogger(FilteredNameSelectionDialog.class);

	public static final String SETTINGS = FilteredNameSelectionDialog.class.getCanonicalName();
	
	
	/*
	 * (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.FilteredCdmResourceSelectionDialog#getSettings()
	 */
	public String getSettings() {
		if(SETTINGS == null){
			throw new IllegalStateException("No SETTINGS set.");
		}
		return SETTINGS;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.dialogs.FilteredItemsSelectionDialog#fillContentProvider(org.eclipse.ui.dialogs.FilteredItemsSelectionDialog.AbstractContentProvider, org.eclipse.ui.dialogs.FilteredItemsSelectionDialog.ItemsFilter, org.eclipse.core.runtime.IProgressMonitor)
	 */
	@Override
	protected void fillContentProvider(AbstractContentProvider contentProvider,
			ItemsFilter itemsFilter, IProgressMonitor progressMonitor)
			throws CoreException {
		List<TaxonNameBase> names = CdmStore.searchNameString("*");
		progressMonitor.beginTask("Looking for references", names.size());
		for (TaxonNameBase name : names){
			contentProvider.add(name, itemsFilter);
			progressMonitor.worked(1);
		}
	}
}
