// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.dialogs;

import java.util.List;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.reference.ReferenceBase;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created 04.06.2009
 * @version 1.0
 */
public class FilteredReferenceSelectionDialog extends
		FilteredCdmResourceSelectionDialog {
	
	private static final Logger logger = Logger
			.getLogger(FilteredReferenceSelectionDialog.class);

	
	public static final String SETTINGS = FilteredReferenceSelectionDialog.class.getCanonicalName();
	
	/**
	 * @param shell
	 * @param title
	 */
	public FilteredReferenceSelectionDialog(Shell shell) {
		super(shell, "Select Reference");
	}


	/* (non-Javadoc)
	 * @see org.eclipse.ui.dialogs.FilteredItemsSelectionDialog#fillContentProvider(org.eclipse.ui.dialogs.FilteredItemsSelectionDialog.AbstractContentProvider, org.eclipse.ui.dialogs.FilteredItemsSelectionDialog.ItemsFilter, org.eclipse.core.runtime.IProgressMonitor)
	 */
	@Override
	protected void fillContentProvider(AbstractContentProvider contentProvider,
			ItemsFilter itemsFilter, IProgressMonitor progressMonitor)
			throws CoreException {
		
		List<ReferenceBase> references = CdmStore.getReferencesByTitle("*");
		progressMonitor.beginTask("Looking for references", references.size());
		for (ReferenceBase reference : references){
			contentProvider.add(reference, itemsFilter);
			progressMonitor.worked(1);
		}		
	}
	
	/*
	 * (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.FilteredCdmResourceSelectionDialog#getSettings()
	 */
	public String getSettings() {
		if(SETTINGS == null){
			throw new IllegalStateException("No SETTINGS set.");
		}
		return SETTINGS;
	}
}
