// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IExportWizard;

import eu.etaxonomy.cdm.io.common.CdmDefaultExport;
import eu.etaxonomy.cdm.io.common.IExportConfigurator;
import eu.etaxonomy.cdm.io.common.IIoConfigurator;

/**
 * @author n.hoffmann
 * @created 24.06.2009
 * @version 1.0
 */
public abstract class AbstractExportWizard<CONFIG extends IIoConfigurator> extends Wizard implements IExportWizard{
	private static final Logger logger = Logger
			.getLogger(AbstractExportWizard.class);
	
	protected final String CONFIGURATION_PAGE = "CONFIGURATION_PAGE"; 
	
	private GenericConfiguratorWizardPage pageConfiguration;
	
	private CdmDefaultExport export;
	
	public boolean doExport(final IExportConfigurator configurator){
		export = new CdmDefaultExport();
		
		Job exportJob = new Job("Export"){
			@Override
			protected IStatus run(IProgressMonitor monitor) {
				return export.invoke(configurator) ? Status.OK_STATUS : Status.CANCEL_STATUS;
			}
		}; 		
		
		exportJob.schedule();
		
		return true;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#addPages()
	 */
	@Override
	public void addPages() {
		super.addPages();
		
		pageConfiguration = GenericConfiguratorWizardPage.Export(CONFIGURATION_PAGE, getConfigurator());
		this.addPage(pageConfiguration);
	}
	
	public abstract CONFIG getConfigurator();
}
