// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io;

import org.apache.log4j.Logger;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

/**
 * @author n.hoffmann
 * @created 04.08.2009
 * @version 1.0
 */
public class ImportFromFileDataSourceWizardPage extends WizardPage {
	private static final Logger logger = Logger
		.getLogger(ImportFromFileDataSourceWizardPage.class);
	
	public static final String PAGE_NAME = "CdmXmlDataSourceWizardPage";

	private static final String[] EXTENSIONS = {"xml"};

	private FileDialog fileDialog;

	private Text text_file;
	
	
	/**
	 * @param pageName
	 */
	protected ImportFromFileDataSourceWizardPage() {
		super(PAGE_NAME);
		
		setTitle("Xml File");
		
		setDescription("Select XML file.");
	}



	/* (non-Javadoc)
	 * @see org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createControl(Composite parent) {
		final Composite composite = new Composite(parent, SWT.NULL);
		
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		composite.setLayout(gridLayout);
		
		Label folderLabel = new Label(composite, SWT.NONE);
		folderLabel.setText("File");
		
		fileDialog = new FileDialog(parent.getShell());
		
		fileDialog.setFilterExtensions(EXTENSIONS);
		
		text_file = new Text(composite, SWT.BORDER);
		text_file.setEditable(false);
		text_file.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		
		Button button = new Button(composite, SWT.PUSH);
		button.setText("Browse...");
		
		button.addMouseListener(new MouseAdapter(){

			/* (non-Javadoc)
			 * @see org.eclipse.swt.events.MouseAdapter#mouseUp(org.eclipse.swt.events.MouseEvent)
			 */
			@Override
			public void mouseUp(MouseEvent e) {
				String path = fileDialog.open();
				text_file.setText(path);
				setPageComplete(true);
			}
			
		});
		
		setControl(composite);
	}

	/**
	 * @return
	 */
	public String getFile() {
		return text_file.getText();
	}
}
