// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.store.operations;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.ExecutionException;
import org.junit.BeforeClass;
import org.junit.Test;

import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.operations.ChangeHomotypicalGroupBasionymOperation;

/**
 * @author n.hoffmann
 * @created 08.04.2009
 * @version 1.0
 */
public class ChangeHomotypicalGroupBasionymOperationTest extends AbstractTaxeditorOperationTest {
	private static final Logger logger = Logger
			.getLogger(ChangeHomotypicalGroupBasionymOperationTest.class);

	private static Synonym synonym;

	private static HomotypicalGroup homotypicalGroup;
	
	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		
		taxon = Taxon.NewInstance(null, null);
		synonym = Synonym.NewInstance(null, null);
		homotypicalGroup = HomotypicalGroup.NewInstance();
		// FIXME homotypical group and basionym related maethods are not implemented in the library
		// wait till this gets done before implementing the test
		
		operation = new ChangeHomotypicalGroupBasionymOperation("", undoContext, taxon, synonym, postOperation);
	}

	/**
	 * Test method for {@link eu.etaxonomy.taxeditor.operations.ChangeHomotypicalGroupBasionymOperation#execute(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)}.
	 * @throws ExecutionException 
	 */
	@Test
	public void testExecuteIProgressMonitorIAdaptable() throws ExecutionException {
		operation.execute(monitor, info);
		
		logger.warn("Wating for functionality in library");
	}

	/**
	 * Test method for {@link eu.etaxonomy.taxeditor.operations.ChangeHomotypicalGroupBasionymOperation#undo(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)}.
	 * @throws ExecutionException 
	 */
	@Test
	public void testUndoIProgressMonitorIAdaptable() throws ExecutionException {
		operation.undo(monitor, info);
		
		logger.warn("Wating for functionality in library");
	}

	/**
	 * Test method for {@link eu.etaxonomy.taxeditor.operations.ChangeHomotypicalGroupBasionymOperation#redo(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)}.
	 * @throws ExecutionException 
	 */
	@Test
	public void testRedoIProgressMonitorIAdaptable() throws ExecutionException {
		operation.redo(monitor, info);
		
		logger.warn("Wating for functionality in library");
	}

	/**
	 * Test method for {@link eu.etaxonomy.taxeditor.operations.AbstractPostOperation#postExecute(CdmBase)}.
	 */
	@Test
	public void testPostExecute() {
		// TODO there is not post operation functionality for this class
		// at the moment. Implement test when there is.
		logger.warn("No post operation functionality for this class");
	}
}
